from PIL.Image import open as op
import numpy as np
import cv2
import os
import random as rd

def load_images(image_path):
    return np.array(op(image_path))

def gray_image(images, path=None, name=None):
    gray_list = []
    num = 0
    array_list = []
    for image in images:
        image_cv2 = np.array(image)
        gray_image_cv2 = cv2.cvtColor(image_cv2, cv2.COLOR_BGR2GRAY)
        if path is not None or name is not None:
            name = f"{name}_{num}.jpg"
            if path is not None:
                name = os.path.join(path, name)
            cv2.imwrite(name, gray_image_cv2)
            num += 1


def new_data_image(images, path=None, name=None):
    data_image_list = []
    for image in images:
        data_images = []
        image = np.array(image)
        data_images.append(cv2.rotate(image, cv2.ROTATE_90_COUNTERCLOCKWISE))
        data_images.append(cv2.rotate(image, cv2.ROTATE_180))
        data_images.append(cv2.rotate(image, cv2.ROTATE_90_CLOCKWISE))

        num = 0  
        if name is not None and path is not None:
                
            for i in data_images:
                file_name = f"{name}_{num}.jpg"
                cv2.imwrite(os.path.join(path, file_name), i)
                num += 1

        elif name is not None:
                
            for i in data_images:
                file_name = f"{name}_{num}.jpg"
                cv2.imwrite(file_name, i)
                num += 1

        data_image_list.extend(data_images)

    return data_image_list

def use_PIL(image):
    return Image.fromarray(image)




def show(name, image, waitKey='q'):
    try:
        img = cv2.imread(image)
        cv2.imshow(name, img)
    except TypeError:
        cv2.imshow(name, image)
    print(f"Image opened successfully")
    while True:
        if cv2.waitKey(1) & 0xFF == ord(waitKey):
            break
    # ปิดหน้าต่าง
    cv2.destroyAllWindows()
    print(f"closed image successfully")
    return

def adjust_img_color(image, number_new=1, color_value=0.5, color_value_end=1.5):
    list_img = []
    for _ in range(number_new+1):
        number = rd.uniform(color_value, color_value_end)
        if number != 1:
            list_img.append(cv2.convertScaleAbs(image, alpha=number))
    return list_img

def resize(image, size):
    return cv2.resize(image, size)